public class Main
{
	public static void main(String[] args)
	{
		jDJTSatLib sat;
		int satCount;
		String satNames[];
    	
		try
		{
			sat = new jDJTSatLib();
		}
		catch(Exception ex)
		{
			System.out.println(ex.getMessage());
			return;
		}

		System.out.println("GetVersionString : "+sat.getVersionString());
		sat.setKeplerPath(System.getProperty("user.dir")+"\\kepler");
		System.out.println("GetKeplerPath\t : "+sat.getKeplerPath());
		satCount = sat.getSatCount();
		System.out.println("GetSatCount\t : "+satCount);
		sat.setObsLat(-33.8);
		sat.setObsLon(18.47);
		sat.setObsHeight(0);
		System.out.println("ObsLat   \t : "+sat.getObsLat());
		System.out.println("ObsLon   \t : "+sat.getObsLon());
		System.out.println("ObjHeight\t : "+sat.getObsHeight());
		
		if (satCount > 0)
		{
			satNames = sat.getSatNames().replaceAll("\"","").split(",");
			
			String Name = satNames[0];
			double JulianTime = sat.DateTimeToJT(35065);
			double ThresholdDeg = 0;
			boolean[] Southbound = new boolean[1]; 
			double[] Azumuth = new double[1];
			double[] Elevation = new double[1];
			double[] Longitude = new double[1];
			double[] Latitude = new double[1];
			double[] Range  = new double[1];
			double[] RangeRate = new double[1];
			double[] Altitude = new double[1];
			double[] Phase = new double[1];
			
			boolean isVisible = sat.IsVisible(Name,JulianTime,ThresholdDeg,Southbound,Azumuth,Elevation,Longitude,Latitude,Range,RangeRate,Altitude,Phase);
			System.out.println("Satellite\t : "+Name);
			System.out.println("IsVisible\t : "+isVisible);
			System.out.println("Southbound\t : "+Southbound[0]);
			System.out.println("Azumuth  \t : "+Azumuth[0]);
			System.out.println("Elevation\t : "+Elevation[0]);
			System.out.println("Longitude\t : "+Longitude[0]);
			System.out.println("Latitude\t : "+Latitude[0]);
			System.out.println("Range    \t : "+Range[0]);
			System.out.println("RangeRate\t : "+RangeRate[0]);
			System.out.println("Altitude\t : "+Altitude[0]);
		}

		sat.Close();
	}
}