﻿Imports System.Windows.Forms

Public Class Form1

    ' README:
    ' This code is based on the 'C#-demo' by Bouanani Nadir nadhir31@yahoo.fr
    ' Simple C# application demonstrating how to make use of David Taylor's SGP4 Satellite Component DLL
    ' See: http://www.satsignal.eu/software/wxtrack.htm#SGP4
    ' Released into the Public Domain
    ' VB.Net version by Tim Makins tim@mapability.com

    ' To get this Solution to work on my Windows10 x64 computer, I had to do the following:
    ' Search > Command Prompt
    ' Right-click the Search Return > click 'Run as Administrator'
    ' Navigate to the directory containing 'DJTSatLib.dll'
    ' Type or Paste: cd /D C:\path-to-this-program\VB.Net-demo                                     ' These days you can Paste the text in to the Command Prompt
    ' Press 'Return'
    ' Type or Paste: REGSVR32 DJTSatLib.dll
    ' Press 'Return'
    ' You will get a message saying: 'DllRegisterServer in DJTSatLib.dll succeeded'
    ' Click 'OK' and close the 'Command Prompt' window
    ' If you get an 0x80004005 error message, you were not in Administrator mode
    ' Go to Solution Explorer > This Project > right-click > Add > Reference > check 'DJTSatLib.dll' > click 'OK'
    ' Solution Explorer > References > DJTSatLib > right-click > Properties > Embed Interop Types > set to 'False'
    ' Solution Explorer > right-click the project-name > Properties > Compile > Target CPU > x86
    ' Build > Build Solution

    ' It is vital that you use the latest Kepler Elements. You can download the list of active satellites from: http://www.celestrak.com/NORAD/elements/active.txt
    ' Other lists can be found here: http://www.celestrak.com/NORAD/elements/
    ' You should place a copy of your list in C:\path-to-this-program\VB.Net-demo\bin\Debug\kepler
    ' The copy should replace the list that is already there

    Public Sub New()
        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
    End Sub


    Public ISat As DJTSatLib.ISatellites = New DJTSatLib.SatellitesClass()                         ' Follow the text above to remove this error
    Private satname As String
    Private mytime As DateTime


    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.Text = "Demo VB.Net using Djtsatlib v " & ISat.VersionString
        ISat.KeplerPath = Application.StartupPath & "\kepler"
        Dim words As String = ISat.SatNames
        Dim split As String() = words.Split(New Char() {""""c, ","c})

        For Each s As String In split
            If s.Trim() <> "" Then ListBox1.Items.Add(s)
        Next

        ListBox1.SelectedIndex = 10
        satname = ListBox1.SelectedItem.ToString()
        label7.Text = "Satellite found " & ISat.SatCount.ToString()
    End Sub


    Private Sub CheckBox1_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox1.CheckedChanged
        Timer1.Enabled = CheckBox1.Checked
    End Sub


    Private Sub TimeChange()
        Dim jt, az, elv, phase, longitude, latitude As Double
        Dim range, range_rate, altitude As Double
        Dim south As Boolean
        Dim x, y, z, xdot, ydot, zdot As Double
        jt = ISat.DateTimeToJT(mytime.ToOADate())
        ISat.IsVisible(satname, jt, 2, south, az, elv, longitude, latitude, range, range_rate, altitude, phase)
        lonlat.Text = "Longitude: " & longitude.ToString("0.000") & "     Latitude: " & latitude.ToString("0.000")
        southbound.Text = "Southbound:  " & south.ToString()
        label_altitude.Text = altitude.ToString("0.000 km")
        label_range.Text = "Range: " & range.ToString("0.000") & " Km"
        label_range_rate.Text = "Range rate: " & range_rate.ToString("0.000") & " Km/s"
        label_elv_az.Text = "Elevation: " & elv.ToString("0.00") & "   Azimuth: " & az.ToString("0.00")
        ISat.SatState(x, y, z, xdot, ydot, zdot)
        satstate_label.Text = "X: " & x.ToString("0.000") & "  Y: " & y.ToString("0.000") & "  Z: " & z.ToString("0.000")
        satstate2_label.Text = "Xdot: " & xdot.ToString("0.000  km/s") & "  Ydot: " & ydot.ToString("0.000 km/s") & "  Zdot: " & zdot.ToString("0.000 km/s")
    End Sub


    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        DateTimePicker1.Value = System.DateTime.UtcNow
    End Sub


    Private Sub DateTimePicker1_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles DateTimePicker1.ValueChanged
        mytime = DateTimePicker1.Value
        TimeChange()
    End Sub


    Private Sub DateTimePicker1_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles DateTimePicker1.Enter
        CheckBox1.Checked = False
    End Sub


    Private Sub ListBox1_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListBox1.SelectedIndexChanged
        satname = ListBox1.SelectedItem.ToString()
        current_sat.Text = "Satellite: " & satname
        TimeChange()
    End Sub

End Class
