Attribute VB_Name = "Module1"
Private Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Const max% = 5000

Global Const pver$ = "Version 0.70 - January 8, 2007"
Type satpass
 name As String * 12
 date As String * 12
 aos As String * 8
 los As String * 8
 elev As String * 2
 long As String * 3
 ns As String * 1
End Type

Global dt As Date
Global utcdate, utchour, min_seconds, days, min_elevation
Global objSatlist As Object, satlist$, passes$
Global isvis As Boolean, pi As Double
Global wxsat(max%) As satpass, xtg%(max%)
Global pdate$, sat$, aos$, los$, elv$, ns$, slong$
Global sname$(max%), sats%, entry%, selected%, dst%, ver$
Global showpassdetails%, passnum%, pno%, dont%
Global stepsec As Integer

Public Sub assignAOS(t$)
Dim u$, p%
'Parse t$, the datastring from ** MakePassList **
pdate$ = getdate(t$)
aos$ = starttime(t$): 'AOS TIME
ns$ = Mid$(t$, 16, 1): 'DIRECTION
u$ = Mid$(t$, 18)
q$ = t$
p% = InStr(u$, " ")
slong$ = twodigit(Str$(360 - Val(Mid$(u$, 1, p% - 1))), 3): 'LONGITUDE
u$ = Mid$(u$, p% + 1)
p% = InStr(u$, " ")
elv$ = twodigit(Mid$(u$, 1, p% - 1), 2): ' ELEVATION
u$ = Mid$(u$, p% + 1)
p% = InStr(u$, " ")
sec$ = Mid$(u$, 1, p% - 1)
sat$ = Mid$(u$, p% + 1): '  SATELLITE NAME
los$ = endtime(aos$, sec$): '  LOS TIME
wxsat(entry%).name = sat$
wxsat(entry%).date = pdate$
wxsat(entry%).aos = aos$
wxsat(entry%).los = los$
wxsat(entry%).elev = elv$
wxsat(entry%).long = slong$
wxsat(entry%).ns = ns$
entry% = entry% + 1
End Sub

Public Sub assignAzEl(t$)
Dim p%, k$
pno% = pno% + 1
If pno% <> passnum% Then Exit Sub
Main.sdetail.Clear
Do: p% = InStr(t$, ",")
k$ = Left$(t$, p% - 1)
Main.sdetail.AddItem Mid$(k$, 2, Len(k$) - 2): 'Remove quotes
t$ = Mid$(t$, p% + 1)
Loop Until InStr(t$, ",") = 0
showpassdetails% = 0
End Sub

Function starttime(x$)
Dim i$
starttime = Mid$(x$, 9, 2) + ":" + Mid$(x$, 11, 2) + ":" + Mid$(x$, 13, 2)
End Function

Public Function endtime(x$, y$)
Dim h%, m%, s%
h% = Val(Mid$(x$, 1, 2))
m% = Val(Mid$(x$, 4, 2))
s% = Val(Mid$(x$, 7, 2))
s% = Val(y$) + s%: If s% > 59 Then s% = s% Mod 60: m% = m% + 1
m% = (Val(y$) \ 60 + m%): If m% > 59 Then m% = m% Mod 60: h% = h% + 1
endtime = twodigit(h%, 2) + ":" + twodigit(m%, 2) + ":" + twodigit(s%, 2)
End Function

Public Function twodigit(i%, n%)
twodigit = Right$("00" + Trim$(Str$(i%)), n%)
End Function

Public Sub init()
Dim i%, retval, s$
On Error GoTo xout
' =====================================
' set error trap to install missing DLL
' =====================================
Set objSatlist = CreateObject("DJTSatLib.Satellites")
ver$ = objSatlist.versionstring

objSatlist.KeplerPath = CurDir
objSatlist.ObsLat = 57.3: 'Set observer's latitude
objSatlist.ObsLon = -2.05: 'Set observer's longitude
objSatlist.ObsHeight = 180: 'Set observer's altitude

'Set up Day Drop-down selector menu
Do: i% = i% + 1: Main.timespan.AddItem Str$(i%): Loop Until i% = 14

'Set start time to current PC date
settime

pi = 4 * Atn(1)
days = 1
min_elevation = 2
min_seconds = 300
sats% = objSatlist.satcount - 1: 'Number of satellites available
stepsec = 2
Exit Sub
xout:
init2
Resume Next
End Sub

Public Function unq(t$)
'Remove quotes from Satellite Names
Dim e%, i%, x$, z$: e% = Len(t$)
Do: i% = i% + 1: x$ = Mid$(t$, i%, 1)
Select Case x$
Case Chr$(34)
Case Else: z$ = z$ + x$
End Select
Loop Until i% = e%
unq = z$
End Function

Public Function getdate(x$)
Dim m%, d%, mm$
m% = Val(Mid$(x$, 5, 2)): d% = Val(Mid$(x$, 7, 2))

Select Case m%
Case 1: mm$ = "January"
Case 2: mm$ = "February"
Case 3: mm$ = "March"
Case 4: mm$ = "April"
Case 5: mm$ = "May"
Case 6: mm$ = "June"
Case 7: mm$ = "July"
Case 7: mm$ = "August"
Case 8: mm$ = "September"
Case 10: mm$ = "October"
Case 11: mm$ = "November"
Case 12: mm$ = "December"
End Select

getdate = mm$ + " " + Str$(d%)
End Function

Public Function rtd(d)
Dim i
i = 57.3 * d
rtd = Int(100 * i) / 100
End Function

Public Sub settime()
Dim k%
t = Now
y$ = Format$(t, "yyyy")
m$ = Format(t, "m")
d$ = Format(t, "dd")
h$ = Format(t, "hh")
k% = Val(h$): k% = k% - dst%
h$ = Trim$(k%)
mi$ = Format(t, "nn")
se$ = Format(t, "ss")
utchour = TimeSerial(h$, mi$, se$)
utcdate = DateSerial(y$, m$, d$)
'Assign current date/time to dt
dt = DateValue(Str$(utcdate)) + TimeValue(Str$(utchour))
End Sub

Public Function dst2(n$)
Dim i%, j$, t$: t$ = n$
i% = Val(Mid$(n$, 1, 2)): i% = i% + dst%: If i% = 24 Then i% = 0
j$ = Right$("0" + Trim$(i%), 2)

Mid$(t$, 1, 2) = j$
dst2 = t$
End Function

Public Sub init2()
Dim retval, s$, win$, nlen%
win$ = Space(255)
nlen% = GetSystemDirectory(win$, 255)
win$ = Left$(win$, nlen%): 'win$ is full path to Syatem Folder
' =====================================
' Registers the DJTSatLib.DLL component (which MUST be in the 'System32' folder
' =====================================
s$ = win$ + "\REGSVR32 " + win$ + "\DJTSatLib.dll"
retval = Shell(s$, 1)
Set objSatlist = CreateObject("DJTSatLib.Satellites")
End Sub

